#! /bin/sh
#
#	0.1: Oct. 22, 2002 by Dai ISHIJIMA
#	0.2: May.  1, 2004 by Dai ISHIJIMA
#

PATH=/bin:/sbin:/:.
export PATH

DISK=/dev/rad0; export DISK
NCYLS=`diskinfo -c $DISK`; export NCYLS
NHEAD=`diskinfo -h $DISK`; export NHEAD
NSECS=`diskinfo -s $DISK`; export NSECS
blks=`expr $NCYLS '*' $NHEAD '*' $NSECS`
bytes=`expr $NCYLS '*' $NHEAD '*' $NSECS '*' 512`
kb=`expr $bytes / 1024`
mb=`expr $kb / 1024`
gb=`expr $mb / 1024`

while echo '' ; do
	#
	# show menu
	echo '================================================================'
	echo "current disk: $DISK, "
	echo "         size: $gb [GB], $mb [MB], $kb [kB], $bytes [B]"
	echo -n "        C/H/S: $NCYLS [cylinders]"
	echo " / $NHEAD [heads] / $NSECS [sectors]"
	echo ''
	echo "0. set current disk"
	echo "1. set disk geometry ($NCYLS * $NHEAD * $NSECS = $blks blocks)"
	echo ''
	echo "2. erase (write '0' to disk '$DISK')"
	echo "3. fill  (write '1' to disk '$DISK')"
	echo "4. noise (write random data to disk '$DISK')"
	echo "5. verify (erase check)"
	echo ''
	echo "6. copy (/dev/rad0 -> /dev/rad1)"
	echo ''
	echo '9. escape to shell'
	echo ''
	echo -n 'Which? [0-9]: '
	#
	# process
	read x
	case "$x" in
	    0)
		echo ''
		echo '--------------------------------'
		echo "current disk is '$DISK'"
		echo -n "enter raw device file name "
		echo -n "(ex. /dev/rad1, /dev/rda0) : "
		read d
		if diskinfo "$d" > /dev/null 2>&1 ; then
			DISK=$d; export DISK
			NCYLS=`diskinfo -c $DISK`; export NCYLS
			NHEAD=`diskinfo -h $DISK`; export NHEAD
			NSECS=`diskinfo -s $DISK`; export NSECS
			blks=`expr $NCYLS '*' $NHEAD '*' $NSECS`
			bytes=`expr $NCYLS '*' $NHEAD '*' $NSECS '*' 512`
			kb=`expr $bytes / 1024`
			mb=`expr $kb / 1024`
			gb=`expr $mb / 1024`
		else
			echo ''
			echo -n "**** can't read '$d', "
			echo "set current disk to '$DISK'"
		fi
		;;
	    1)
		echo ''
		echo '--------------------------------'
		echo -n "Enter # of cylinders [$NCYLS]: "
		read n
		if expr "$n" '>=' 0 > /dev/null 2>&1 ; then
			NCYLS=`expr "$n" + 0`; export NCYLS
		fi
		echo -n "Enter # of heads (tracks/cylinder) [$NHEAD]: "
		read n
		if expr "$n" '>=' 0 > /dev/null 2>&1 ; then
			NHEAD=`expr "$n" + 0`; export NHEAD
		fi
		echo -n "Enter # of sectors (sectors/track) [$NSECS]: "
		read n
		if expr "$n" '>=' 0 > /dev/null 2>&1 ; then
			NSECS=`expr "$n" + 0`; export NSECS
		fi
		blks=`expr $NCYLS '*' $NHEAD '*' $NSECS`
		if [ $blks -le 0 ]; then
			echo ''
			echo -n "**** Hmm... total blocks wrong "
			echo -n "($NCYLS * $NHEAD * $NSECS = $blks"
			echo " blocks),"
			echo "**** using default value instead"
			NCYLS=`diskinfo -c`; export NCYLS
			NHEAD=`diskinfo -h`; export NHEAD
			NSECS=`diskinfo -s`; export NSECS
			blks=`expr $NCYLS '*' $NHEAD '*' $NSECS`
		fi
		bytes=`expr $NCYLS '*' $NHEAD '*' $NSECS '*' 512`
		kb=`expr $bytes / 1024`
		mb=`expr $kb / 1024`
		gb=`expr $mb / 1024`
		;;
	    2)
		echo ''
		echo '--------------------------------'
		/bin/sh /bin/e.sh -z $DISK
		;;
	    3)
		echo ''
		echo '--------------------------------'
		/bin/sh /bin/e.sh -f $DISK
		;;
	    4)
		echo ''
		echo '--------------------------------'
		/bin/sh /bin/e.sh -r $DISK
		;;
	    5)
		echo ''
		echo '--------------------------------'
		/bin/sh /bin/v.sh $DISK
		;;
	    6)
		echo ''
		echo '--------------------------------'
		/bin/sh /bin/c.sh
		;;
	    9)
		echo ''
		echo '--------------------------------'
		/bin/sh -i
		;;
	esac
done

exit 0


